/*
 * NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDependienteDep.java
 *
 * Created on 24 de marzo de 2007, 07:50 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 * @author Julian
 */
public class NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDependienteDep
		extends AbstractRule {

	private Pattern pattern;

	public NoCoincideLongitudoTipoCampoAlfanumericoNumericoObligatorioDependienteDep() {
		String patternStr = "[^A-Z0-9/Ñ]";
		pattern = Pattern.compile(patternStr);

	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {

		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];

		if (codigoNovedad.equals((String) getParams()[1])) {

			if (registro[new Integer((String) getParams()[2]).intValue()]
					.equals(getParams()[3])) {
				if (field.length() < new Integer((String) getParams()[4])
						.intValue()
						|| field.length() > new Integer((String) getParams()[5])
								.intValue())
					return true;
				Matcher matcher = pattern.matcher(field);
				return matcher.find();

			}
		}
		return false;
	}

}
